package cn.iocoder.yudao.module.order.enums;

import cn.hutool.core.util.ArrayUtil;
import cn.iocoder.yudao.framework.common.util.json.core.IntArrayValuable;
import lombok.AllArgsConstructor;
import lombok.Getter;

import java.util.Arrays;

/**
 * 常态化提醒异常国际化配置枚举
 * 自定义提醒以前端传值为准
 *
 * @author zhengYi
 * @date 2022-11-15 23:58:34
 */
@AllArgsConstructor
@Getter
public enum OrderRemindExceptionEnum implements IntArrayValuable {
    // TODO 以下为示例值 按实际值修改
    CUSTOMS(1, 1, ""),//报关
    SHIPPING(2, 2, ""),// 起运
    ARRIVAL(3, 3, ""),//到港

    ;
    public static final int[] ARRAYS = Arrays.stream(values()).mapToInt(OrderRemindExceptionEnum::getValue).toArray();

    /**
     * 提醒异常类型 TODO 请定义好类型
     */
    private final Integer type;

    /**
     * 提醒异常值
     */
    private final Integer value;

    /**
     * 提醒异常国际化配置说明
     */
    private final String desc;

    public static OrderRemindExceptionEnum valueOf(Integer value) {
        return ArrayUtil.firstMatch(remindException -> remindException.getValue().equals(value), OrderRemindExceptionEnum.values());
    }

    public static OrderRemindExceptionEnum typeOf(Integer type) {
        return ArrayUtil.firstMatch(remindException -> remindException.getType().equals(type), OrderRemindExceptionEnum.values());
    }

    @Override
    public int[] array() {
        return ARRAYS;
    }
}
